task deduped_Metrics {

    File ref_dir
	String fasta
	File Dedup_bam
	File Dedup_bam_index
	String sample = basename(Dedup_bam,".sorted.deduped.bam")
	String docker
	String cluster_config
	String disk_size


	command <<<
		set -o pipefail
		set -e
		java -jar picard.jar CollectAlignmentSummaryMetrics /
			-I ${Dedup_bam} /
			-O ${sample}_deduped_aln_metrics.txt /
			-R ${ref_dir}/${fasta} /
			--VALIDATION_STRINGENCY LENIENT
		java -jar picard.jar CollectInsertSizeMetrics /
			-I ${Dedup_bam} /
			-O ${sample}_deduped_is_metrics.txt /
			-H ${sample}_deduped_is_metrics.pdf
		java -jar picard.jar CollectQualityYieldMetrics /
			-I ${Dedup_bam} /
			-O ${sample}_deduped_QualityYield.txt

		java -jar picard.jar CollectWgsMetrics 
			-I ${Dedup_bam} /
			-O ${sample}_deduped_WgsMetricsAlgo.txt /
			-R ${ref_dir}/${fasta} /
			--VALIDATION_STRINGENCY LENIENT

	>>>

	runtime {
		docker:docker
    	cluster: cluster_config
    	systemDisk: "cloud_ssd 40"
    	dataDisk: "cloud_ssd " + disk_size + " /cromwell_root/" 
	}

	output {
		# File deduped_coverage_metrics_sample_summary = "${sample}_deduped_coverage_metrics.sample_summary"
		# File deduped_coverage_metrics_sample_statistics = "${sample}_deduped_coverage_metrics.sample_statistics"
		# File deduped_coverage_metrics_sample_interval_statistics = "${sample}_deduped_coverage_metrics.sample_interval_statistics"
		# File deduped_coverage_metrics_sample_cumulative_coverage_proportions = "${sample}_deduped_coverage_metrics.sample_cumulative_coverage_proportions"
		# File deduped_coverage_metrics_sample_cumulative_coverage_counts = "${sample}_deduped_coverage_metrics.sample_cumulative_coverage_counts"
		# File deduped_mean_quality = "${sample}_deduped_mq_metrics.txt"
		# File deduped_qd_metrics = "${sample}_deduped_qd_metrics.txt"
		# File deduped_gc_summary = "${sample}_deduped_gc_summary.txt"
		# File deduped_gc_metrics = "${sample}_deduped_gc_metrics.txt"
		File dedeuped_aln_metrics = "${sample}_deduped_aln_metrics.txt"
		File deduped_is_metrics = "${sample}_deduped_is_metrics.txt"
		File deduped_QualityYield = "${sample}_deduped_QualityYield.txt"
		File deduped_wgsmetrics = "${sample}_deduped_WgsMetricsAlgo.txt"
	}
}
